<script lang="ts" setup>
import { useReceiptStore } from '@/stores/receipt'
import type { ReceiptItem } from '@/types/ReceiptItem'

import { computed, ref } from 'vue'
import type { VSheet } from 'vuetify/components'

const receiptStore = useReceiptStore()

const div = ref<HTMLElement | null>(null)

const scrollToBottom = () => {
  div.value!.scrollTo(0, div.value!.scrollHeight)
}
const props = withDefaults(defineProps<{
  editable: boolean
}>(), {
  editable: true
})
defineExpose({
  scrollToBottom
})
</script>
<template>
  <div class="overflow-auto" ref="div">
    <v-sheet max-width="600" min-width="300" height="280" elevation="3">
      <v-table>
        <thead>
          <tr>
            <td>#</td>
            <td>ชื่อ</td>
            <td>ราคา</td>
            <td>จำนวน</td>
            <td>ราคารวม</td>
            <td></td>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(item, index) of receiptStore.receiptItems" :key="index">
            <td>{{ index + 1 }}</td>
            <td>{{ item.name }}</td>
            <td>{{ item.price }}</td>
            <td>
              <v-btn v-if="props.editable === true" icon="mdi-minus" density="compact" @click="() => {
                receiptStore.decUnitOfReceiptItem(item)
              }
                "></v-btn><span class="pl-3 pr-3">{{ item.unit }}</span>
              <v-btn v-if="props.editable === true" icon="mdi-plus" density="compact" @click="() => {
                receiptStore.incUnitOfReceiptItem(item)
              }
                "></v-btn>
            </td>
            <td>{{ item.price * item.unit }}</td>
            <td>
              <v-btn v-if="props.editable === true" density="compact" icon="mdi-delete" color="red" @click="() => {
                receiptStore.removeItem(item)
              }
                "></v-btn>
            </td>
          </tr>
        </tbody>
      </v-table>
    </v-sheet>
  </div>
</template>
